
open (OUT,">EUcodes.c")||die("Write error\n");

opendir (DIR, ".");
@direntries=readdir(DIR);
closedir(DIR);
  
@tabellen=();
@schalter=();
@liste=();


foreach $filename (@direntries){
  if ($filename=~/\d+\.txt/i){
    print "Processing $filename\n";
    open (IN,$filename);
    $status=0;   
    while (<IN>){
      
      if(0==$status){ #Anfang (Kommentar), Codenr
        if (/Code\s+(\d+)/){
          $code=$1;
          push(@tabellen,"\/*\n");
          push(@tabellen, $_);
          push(@schalter,"#define CODE$code \t 1\n"); 
          push(@liste,"#if CODE$code\n\t&Code$code,\n#endif\n\n"); 
          $status++;
        }  
      }else{  
      
      if(1==$status){ #Kommentar
        if (/Carrier Freq/){
          if (/Carrier Freq\s*=\s*(\d+\.\d+)\s+KHz/i){
            $frq=$1  * 1000;
          }else{
            $frq="ERROR: FRQ not detected. Line=[$_]\n";
          }
          push(@tabellen,"*\/\n#if CODE$code\n");
          push(@tabellen,"const Tpowercode Code$code PROGMEM = {\n");
          push(@tabellen,"  freq_to_timerval($frq), // $frq Hz Carrier\n  { \n");
          $status++; 
        }else{
          push(@tabellen,$_);
        }  
      }else{
      
      if(2==$status){ #vor Tabelle
        $status++ if /---|--- /;
      }else{

      if(3==$status){ #Tabelle
        /^\s+(\d+)\s+(\d+)/;
        $on=$1; 
        $off=$2;
        if ($off>0){
          push(@tabellen,"\t{\t $on, \t $off\t },\n");
        }else{
          push(@tabellen,"\t{\t $on, \t 0\t }}\n}; //End code $code\n#endif\n\n\n");
          $status++;
        }
      }
        }}} #Else
    }#while
  }#if
  close IN;

}
$header=<<EOT;
#include <avr/io.h>             // this contains all the IO port definitions
#include <avr/pgmspace.h>       // definitions or keeping constants in program memory
#include "main.h"

#define freq_to_timerval(x) ((F_CPU / x - 1 )/ 2)

// table of POWER codes

EOT
print OUT $header;
print OUT @schalter;
print OUT @tabellen;
print OUT "\n\nconst Tpowercode *powerCodes[] PROGMEM  = {\n";
print OUT @liste;
print OUT "};\nuint8_t num_codes = (sizeof(powerCodes)/sizeof(*powerCodes));\n//EOF\n";

close OUT;



















